#!/usr/bin/env python
#-*- coding:utf-8 –*-
#-----------------------------------------------------------------------------
# $Header: $
#-----------------------------------------------------------------------------
# Summary:           Implementation of Channel Adjust
#
# Authors:           Jensen.Cai
#
# Started:           4/20/2015
#
# Version:           V1.7R1
#
# Copyright 2013-2016 Siglent Corporation. All Rights Reserved.
#
#-----------------------------------------------------------------------------
 
import sys, time, math
sys.path.append(sys.path[0]+'\\Prod Lib')
from reminder import popup
from test_info import testInfo_show
from win32com_excel import *
from device_remote import *
from param import *
from file import *

from FeedbackAdjust import *
from DCMeasure import *
from DutyCalib import *
from DutyCalib_x import *
from VertAccCalib import *
from FreqCounterCal import *
#from SineTest import *

#-----------------------------------------------------------------------------
class ChannelAdjust(ParameterInit):
    def __init__(self):
        super(ChannelAdjust, self).__init__()
    
    def CHAdj_main(self):
        print 'Starting Channel Adjust Process...\n'
        
        self.step1 = FeedbackAdjust()
        self.cal_fbChannel()
        self.__fail_check(self.step1.fail_info)
        
        self.self_cal()
        
        self.step2 = DCMeasure()
        self.test_DC()
        self.__fail_check(self.step2.fail_info)
        
        if self.adj_sch == '1-0':
            self.step3 = DutyCalib()
            self.cal_sqrDuty()
            self.__fail_check(self.step3.fail_info)
        elif self.adj_sch == '1-X':
            #self.step2_5 = SineTest()
            #self.test_sine()
            self.step3 = DutyCalib_x()
            self.cal_sqrDuty()
            self.__fail_check(self.step3.fail_info)
        if self.adj_sch in ['5-2', '2-0', '1-X']:
            self.step4 = VertAccCalib()
            self.step4.VA_ch_list.reverse()
            self.cal_vertAcc()
            self.__fail_check(self.step4.fail_info)
        if self.adj_sch =='2-0':
            self.step5 = FrqCnt()
            self.cal_frqCnt()
            self.__fail_check(self.step5.fail_info)
        
        print 'The Channel Adjust Process is Over'
        testInfo_show([u'通道校正完毕，请进行下一步操作', 'Channel Adjust: Pass'])
        
    def cal_fbChannel(self):
        self.step1.FBCal_main()
        self.step1.saveAndClose()
    
    def self_cal(self):
        print '\nStarting Self Adjust Process...'
        if self.adj_sch in ['0-0', '1-0', '5-0', '5-1', '5-2']:
            popup(u'注意! Notice!', u'请手工进行自校正，校正结束后点击OK继续\n\nPlease perform self-adjust manually, then click OK to continue')
        else:
            self.self_adjust()
            selfCal_state = self.get_selfCal_state()
            while selfCal_state == 0:
                time.sleep(5)
                selfCal_state = self.get_selfCal_state()
        time.sleep(5)
        print '\nSelf Adjust Process is done\n'
        
    def test_DC(self):
        self.step2.DCTest_main()
        self.step2.saveAndClose()
    
    #def test_sine(self):
        #self.step2_5.show_result()
        
    def cal_sqrDuty(self):
        self.step3.DutyCal_main()
        self.step3.saveAndClose()
        
    def cal_vertAcc(self):
        self.step4.VACal_main()
        self.step4.saveAndClose()
    
    def cal_frqCnt(self):
        self.step5.make_file()
        self.step5.cal()
        self.step5.test()
        self.step5.saveAndClose()
        
    def __fail_check(self, fail_info):
        if fail_info == []:
            pass
        else:
            fail_info.insert(0, u'通道校正失败')
            fail_info.insert(1, 'Channel Adjust: Fail')
            testInfo_show(fail_info)
        
if __name__ == '__main__':
    proc = ChannelAdjust()
    proc.CHAdj_main()
