#!/usr/bin/env python
#-*- coding:utf-8 –*-
#-----------------------------------------------------------------------------
# $Header: $
#-----------------------------------------------------------------------------
# Summary:          Implementation of Test Information Dialog
#
# Authors:          Jensen.Cai
#
# Started:          11/25/2014
#
# Version:          V1.7R1
#  
# Copyright 2013-2016 Siglent Corporation. All Rights Reserved.
#
#-----------------------------------------------------------------------------

import sys
from PyQt4.QtCore import *  
from PyQt4.QtGui import *  
import time, datetime

#-----------------------------------------------------------------------------

QTextCodec.setCodecForTr(QTextCodec.codecForName("utf8"))  

#-----------------------------------------------------------------------------
class InfoBox(QDialog):  
    def __init__(self, printInfo, parent=None):
        #弹出信息框的基本布局
        super(InfoBox, self).__init__(parent)
        
        self.left_info = []
        self.right_info = []
        for n in range(0, len(printInfo)):
            if n % 2 == 0:
                self.left_info.append(printInfo[n])
            elif n % 2 == 1:
                self.right_info.append(printInfo[n])

        left_label=QLabel(self.tr('检测结果'))
        right_label=QLabel(self.tr('Test Result'))
        self.left_box = QTextBrowser()
        self.right_box = QTextBrowser()
  
        layout=QGridLayout()
        layout.addWidget(left_label, 0, 1)
        layout.addWidget(right_label, 0, 2)
        layout.addWidget(self.left_box, 1, 1, 10, 1)
        layout.addWidget(self.right_box, 1, 2, 10, 1)
  
        self.setLayout(layout)  
  
        self.setWindowTitle(self.tr('信号源自动化调试和检测 AWG Test'))

        self.start_threads()

    def start_threads(self): #8
        thread = InfoThread(self)                  # 创建左边线程
        thread.trigger.connect(self.update_text_l) # 连接信号 
        thread.setup(self.left_info)               # 传递参数  
        thread.start()                             # 启动线程
        
        thread = InfoThread(self)                  # 创建右边线程
        thread.trigger.connect(self.update_text_r) # 连接信号
        thread.setup(self.right_info)              # 传递参数  
        thread.start()                             # 启动线程
  
    def update_text_l(self, message): 
        self.left_box.insertPlainText(message)
    def update_text_r(self, message): 
        self.right_box.insertPlainText(message) 

#-----------------------------------------------------------------------------
class InfoThread(QThread):
    trigger = pyqtSignal(str)     # trigger传输的内容是字符串  
    def __init__(self, parent=None):  
        super(InfoThread, self).__init__(parent)

    def setup(self, txt_list):  
        self.txt = txt_list  
    
    def run(self): 
        self.print_func()  
      
    def print_func(self):
        #将传入信息列表的元素逐个传输到打印框
        for i in range(0, len(self.txt)): 
            self.trigger.emit(self.txt[i]+'\n')

#-----------------------------------------------------------------------------
def testInfo_show(info_list):
    app=QApplication(sys.argv)
    info_box = InfoBox(info_list)
    info_box.show()
    sys.exit(app.exec_())

if __name__ == '__main__':
    testInfo_show([u'左边', 'right', u'左边', 'right', u'左边', 'right', u'左边', 'right', u'左边', 'right', u'左边', 'right', u'左边', 'right', u'左边', 'right'])
